package opendic;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLConnection;
import java.net.UnknownHostException;
import java.nio.CharBuffer;
import java.nio.charset.CharacterCodingException;
import java.nio.charset.Charset;
import java.nio.charset.CharsetDecoder;

import com.sun.corba.se.impl.ior.ByteBuffer;

public class EnglishDic implements Dictionary {

	public String getHtml(String words) {
		return urlToHtml("http://engdic.daum.net/dicen/search.do?m=all&endic_kind=all&q="
				+ words);
	}

	public String urlToHtml(String urlstring) {
		try {
			URL url = new URL(urlstring);
			URLConnection urlcon = url.openConnection();
			urlcon.setDoOutput(true);

			BufferedReader buffer;
			try {
				buffer = new BufferedReader(new InputStreamReader(urlcon
						.getInputStream()));
			} catch (UnknownHostException e) {
				return "Ʈ Ҽ ϴ.";
			} catch (IOException e) {
				return null;
			}

			String message = new String(), line;
			while ((line = buffer.readLine()) != null) {
				message += line + "\n";
			}
			buffer.close();
			return setHtml(message);

		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
	 
	private String setHtml(String message) {
		int begin = message.indexOf("<div class=\"verb  line\">");
		int end = message.indexOf("<div class=\"synonym synonym_search  line\">");
		if (begin < 0)
			return "ܾ ã ߽ϴ.";

		return "<html>"	+ message.substring(begin, end)	+ "</html>";
	}
}
