package opendic;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.net.UnknownHostException;
import java.nio.charset.Charset;

public class JapaneseDic implements Dictionary {

	public String getHtml(String words) {
		return urlToHtml("http://jpdic.daum.net/dicjp/search_list_desc.do?type=jp&q=" 
				+ words);
	}

	public String urlToHtml(String urlstring) {
		try {
			URL url = new URL(urlstring);
			URLConnection urlcon = url.openConnection();
			urlcon.setDoOutput(true);

			BufferedReader buffer;
			try {
				buffer = new BufferedReader(new InputStreamReader(urlcon
						.getInputStream(), Charset.forName("euc-jp")));
			} catch (UnknownHostException e) {
				return "Ʈ Ҽ ϴ.";
			} catch (IOException e) {
				return null;
			}

			String message = new String(), line;
			while ((line = buffer.readLine()) != null) {
				message += line + "\n";
			}
			buffer.close();
			return setHtml(message);

		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	private String setHtml(String message) {
		int begin = message
				.indexOf("<div id=\"result_content_view\">");
		int end = message.indexOf("<!--##### ˻ End #####-->");
		if (begin < 0)
			return "ܾ ã ϴ.";
		return "<html><font size=-1>"
				+ message.substring(begin, end) + "</html>";
	}

	private String getImage(String html) {
		StringBuffer sbuf = new StringBuffer(html);
		int begin = 0;
		while ((begin = sbuf.indexOf("<img src=\"/")) > 0) {
			sbuf.insert(begin + 10, "http://jpdic.daum.net");
		}
		return sbuf.toString();
	}
}
